Foreman - Bug #12959

Host search based on fact value using LIKE clause does’'nt work
12/30/2015 11:35 AM - Brice Sauvajon

Status: Closed
Priority: High
Assignee: Dominic Cleal
Category: Search
Target version: 1.10.1

Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.10.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3026
Description
Hi,

If | search hosts using a fact value and a ~ it doesn't work as in 1.9.3.

For exemple, if | want to find the hosts having the fact my_fact containing the string fact1 (but can be fact1,fact2,fact3,...), the
expression "facts.my_fact ~ fact1" will give me only the hosts for which my_fact is exactly fact1

If I try to use _ or * wildcards it does'nt change anything.
If | use fact1 I've got an error : "too few arguments”.

If | call the url "/hosts?format=yaml|&rundeck=true&search=+facts.my_fact+~+%25fact1%25" | see an error in the logs :

2015-12-30T17:30:47 [app] [I]

+%25factl%25" for 172.16.1.250 at 2015-12-30 17:30:47 +0100

2015-12-30T17:30:47
2015-12-30T17:30:47
5"}
2015-12-30T17:30:47

| ArgumentError: too few arguments

| /usr/share/foreman/vendor/ruby/2.
70:in %"

| /usr/share/foreman/vendor/ruby/2.
70:in %'

| /usr/share/foreman/vendor/ruby/2.

[app] [I]
[app] [I]

:121:in “sanitize_sqgl_array'
| /usr/share/foreman/vendor/ruby/2.
:28:in “sanitize_sqgl_for_conditions'
| /usr/share/foreman/vendor/ruby/2.
methods.rb:324:in "build_where'

Parameters:

{"rundeck"=>"true",

[app] [W] Action failed

Started GET "/hosts?format=yamlé&rundeck=true&search=+facts.my_~fact+~

Processing by HostsController#index as YAML
"search"=>" facts.my_fact ~ $factl

1.0/gems/fast_gettext-0.9.2/1ib/fast_gettext/vendor/string.rb:

1.0/gems/fast_gettext-0.9.2/1ib/fast_gettext/vendor/string.rb:

1.0/gems/activerecord-3.2.21/1ib/active_record/sanitization.rb

1.0/gems/activerecord-3.2.21/1ib/active_record/sanitization.rb

1.0/gems/activerecord-3.2.21/1ib/active_record/relation/query_

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1lib/active_record/relation/query_

methods.rb:136:in “where'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/scoped_search-3.2.2/1ib/scoped_search/definition.rb:2

56:in "block in register_named_scope!'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1ib/active_record/scoping/named.r

b:178:in “call’

| /usr/share/foreman/vendor/ruby/2.
b:178:in “block (2 levels) in scope'

| /usr/share/foreman/vendor/ruby/2.
.rb:41:1in “block in unscoped'

| /usr/share/foreman/vendor/ruby/2.
:in "block in scoping'

| /usr/share/foreman/vendor/ruby/2.
n “with_scope'

| /usr/share/foreman/vendor/ruby/2.
:in " scoping'

| /usr/share/foreman/vendor/ruby/2.
.rb:41:1in “unscoped’
1.0/gems/activerecord-3.2.21/1ib/active_record/scoping/named.r

1.0/gems/activerecord-3.2.21/1lib/active_record/scoping/default

1.0/gems/activerecord-3.2.21/1ib/active_record/relation.rb:241

1.0/gems/activerecord-3.2.21/1ib/active_record/scoping.rb:98:1i

1.0/gems/activerecord-3.2.21/1ib/active_record/relation.rb:241

1.0/gems/activerecord-3.2.21/1lib/active_record/scoping/default
| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1ib/active_record/scoping/named.r
b:178:in “block in scope'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1ib/active_record/relation/delega
tion.rb:14:in “block in search_for'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1ib/active_record/relation.rb:241
:in "block in scoping'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1ib/active_record/scoping.rb:98:1
n “with_scope'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1lib/active_record/relation.rb:241
:in " scoping'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.2.21/1lib/active_record/relation/delega
tion.rb:14:in "search_for'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/foreman_host_rundeck-0.0.2/app/controllers/concerns/f
oreman_host_rundeck/hosts_controller_extensions.rb:13:in "index_with_rundeck'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_controller/metal/implici
t_render.rb:4:in "“send_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/abstract_controller/base.rb:167
:in “process_action’

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_controller/metal/renderi
ng.rb:10:in “process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/abstract_controller/callbacks.r
b:18:in "block in process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
649:1in “block (4 levels) in _run__2499070075575149213__ process_action__4570805294882249613__callba
cks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
215:in "block in _conditional_callback_around_8158"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
326:in “around'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
310:in " _callback_around_2510"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
214:in " _conditional_callback_around_8158"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
637:in “block (3 levels) in _run__2499070075575149213__ process_action__4570805294882249613__callba
cks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
215:in “block in _conditional_callback_around_8157"

| /usr/share/foreman/app/controllers/concerns/application_shared.rb:13:in "set_timezone'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
214:in " _conditional_callback_around_8157"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
636:1in “block (2 levels) in _run__2499070075575149213__ process_action_ 4570805294882249613__callba
cks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
215:in “block in _conditional_callback_around_8156"

| /usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in "“clear_thread'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
214:in " _conditional_callback_around_8156"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
448:in "block in _run_ 2499070075575149213__ process_action__4570805294882249613__callbacks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
215:in “block in _conditional_callback_around_8155"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
326:in “around'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
310:in " _callback_around_13'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
214:in ~_conditional_callback_around_8155"

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
414:in " _run__2499070075575149213__process_action_ 4570805294882249613__callbacks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
405:in " __run_callback"'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
385:in ' _run_process_action_callbacks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
8l:in “run_callbacks'

05/18/2024 2/5




| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/abstract_controller/callbacks.r

b:17:in “process_action’

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_controller/metal/rescue.

rb:29:in "process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack—-3.2.21/1ib/action_controller/metal/instrum

entation.rb:30:in “block in process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/notifications

.rb:123:in “block in instrument'

| /usr/share/foreman/vendor/ruby/2.1.

/instrumenter.rb:20:in " instrument'

| /usr/share/foreman/vendor/ruby/2.1.

.rb:123:in " instrument'

| /usr/share/foreman/vendor/ruby/2.1.

entation.rb:29:in “process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.

wrapper.rb:207:in 'process_action'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activerecord-3.

ller_runtime.rb:18:in "process_action’

| /usr/share/foreman/vendor/ruby/2.

:in ‘process'

| /usr/share/foreman/vendor/ruby/2.

b:45:in ‘process'

| /usr/share/foreman/vendor/ruby/2.

in “dispatch'

| /usr/share/foreman/vendor/ruby/2.

legation.rb:14:in “dispatch'’

| /usr/share/foreman/vendor/ruby/2.

in "block in action'

| /usr/share/foreman/vendor/ruby/2.

et.rb:73:in “call'

| /usr/share/foreman/vendor/ruby/2.

et.rb:73:in “dispatch’

| /usr/share/foreman/vendor/ruby/2.

et.rb:36:in “call'

| /usr/share/foreman/vendor/ruby/2.

all'

| /usr/share/foreman/vendor/ruby/2.
| /usr/share/foreman/vendor/ruby/2.
| /usr/share/foreman/vendor/ruby/2.

et.rb:608:in “call'

| /usr/share/foreman/vendor/ruby/2.

:in “call’

| /usr/share/foreman/vendor/ruby/2.

7:in “call'

| /usr/share/foreman/vendor/ruby/2.

headers.rb:27:in “call'

| /usr/share/foreman/vendor/ruby/2.

_standards_support.rb:17:in “call'

| /usr/share/foreman/vendor/ruby/2.
| /usr/share/foreman/vendor/ruby/2.
| /usr/share/foreman/vendor/ruby/2.

.rb:14:in “call'

| /usr/share/foreman/vendor/ruby/2.

ms_parser.rb:21:in “call'

4o

0/gems/actionpack-3.2.
.0/gems/actionpack-3.2.
.0/gems/actionpack-3.2.
.0/gems/actionpack-3.2.
.0/gems/actionpack-3.2.
.0/gems/actionpack-3.2.
.0/gems/actionpack-3.2.

.0/gems/actionpack-3.2.

0/gems/activesupport-3.2.21/1ib/active_support/notifications
0/gems/activesupport-3.2.21/1ib/active_support/notifications

0/gems/actionpack—-3.2.21/1ib/action_controller/metal/instrum

21/1lib/action_controller/metal/params_

2.21/1lib/active_record/railties/contro

21/1lib/abstract_controller/base.rb:121

21/1lib/abstract_controller/rendering.r

21/lib/action_controller/metal.rb:203:

21/1lib/action_controller/metal/rack_de

21/1lib/action_controller/metal.rb:246:

21/1lib/action_dispatch/routing/route_s

21/1lib/action_dispatch/routing/route_s

21/1lib/action_dispatch/routing/route_s

.0/gems/journey-1.0.4/1ib/journey/router.rb:68:in ‘block in c

.0/gems/journey—-1.0.4/1ib/journey/router.rb:56:in "each'
.0/gems/journey—-1.0.4/1ib/journey/router.rb:56:in “call'

.0/gems/actionpack-3.2.21/1lib/action_dispatch/routing/route_s

.0/gems/apipie-rails-0.2.6/1lib/apipie/static_dispatcher.rb:65

.0/gems/apipie-rails-0.2.6/1lib/apipie/extractor/recorder.rb:9

.0/gems/apipie-rails-0.2.6/1lib/apipie/middleware/checksum_in_

.0/gems/actionpack-3.2.21/1lib/action_dispatch/middleware/best

.0/gems/rack-1.4.7/1lib/rack/etag.rb:23:in “call'

.0/gems/rack-1.4.7/1ib/rack/conditionalget.rb:25:in ‘call'

.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/head

.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/para

| /usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:9:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/flas

h.rb:242:in “call'

| /usr/share/foreman/vendor/ruby/2.

ntext'

| /usr/share/foreman/vendor/ruby/2.

11"

| /usr/share/foreman/vendor/ruby/2.

ies.rb:341:in “call'

| /usr/share/foreman/vendor/ruby/2.

64:in “call'

| /usr/share/foreman/vendor/ruby/2.
.0/gems/rack-1.4.7/1ib/rack/session/abstract/id.rb:210:1in

.0/gems/rack-1.4.7/1ib/rack/session/abstract/id.rb:205:in

‘co

‘ca

.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/cook

.0/gems/activerecord-3.2.21/1ib/active_record/query_cache.rb:

.0/gems/activerecord-3.2.21/1ib/active_record/connection_adap
ters/abstract/connection_pool.rb:479:in “call’
| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/call
backs.rb:28:in "block in call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1lib/active_support/callbacks.rb:
405:1in " _run_ 640040847829197367__call_ 791296085174225863__callbacks"'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
405:1in " __ _run_callback"'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/callbacks.rb:
385:in " _run_call_callbacks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport-3.2.21/1ib/active_support/callbacks.rb:
8l:in “run_callbacks'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/call
backs.rb:27:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/remo
te_ip.rb:31:in ‘call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/debu
g_exceptions.rb:16:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/show
_exceptions.rb:56:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/railties—-3.2.21/1ib/rails/rack/logger.rb:32:in “call_
app'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/railties-3.2.21/1ib/rails/rack/logger.rb:18:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack-3.2.21/1ib/action_dispatch/middleware/requ
est_id.rb:22:in “call'’

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.4.7/1ib/rack/methodoverride.rb:21:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.4.7/1lib/rack/runtime.rb:17:in “call’

| /usr/share/foreman/vendor/ruby/2.1.0/gems/activesupport—-3.2.21/1ib/active_support/cache/strateg
y/local_cache.rb:72:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.4.7/1ib/rack/lock.rb:15:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/actionpack—-3.2.21/1ib/action_dispatch/middleware/stat
ic.rb:83:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack-cache-1.2/1ib/rack/cache/context.rb:136:in ' forw

ard'’

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack-cache-1.2/1ib/rack/cache/context.rb:245:in " fetc
h'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack—-cache-1.2/1lib/rack/cache/context.rb:185:in " look
up'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack—-cache-1.2/1ib/rack/cache/context.rb:66:in “call!
'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack—-cache-1.2/1ib/rack/cache/context.rb:51:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/railties-3.2.21/1ib/rails/engine.rb:484:in “call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/railties-3.2.21/1ib/rails/application.rb:231:in “call
'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/railties—-3.2.21/1ib/rails/railtie/configurable.rb:30:
in "method_missing'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/rack-1.4.7/1ib/rack/builder.rb:134:in ‘call'
| .0/gems/rack-1.4.7/1ib/rack/urlmap.rb:64:in ‘block in call'
| .0/gems/rack-1.4.7/1ib/rack/urlmap.rb:49:in ‘each’
| .0/gems/rack-1.4.7/1ib/rack/urlmap.rb:49:in ‘call’
| /usr/lib/ruby/vendor_ruby/phusion_passenger/rack/thread_handler_extension.rb:74:in "“process_req
uest'
| /usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:141:in "“accept_an
d_process_next_request'

| /usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:109:in "main_loop
\}

/usr/share/foreman/vendor/ruby/2.
/usr/share/foreman/vendor/ruby/2.

[ =

/usr/share/foreman/vendor/ruby/2.

| /usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler.rb:455:in “block (3 levels) in star
t_threads'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/logging-2.0.0/1ib/logging/diagnostic_context.rb:448:1
n ‘call'

| /usr/share/foreman/vendor/ruby/2.1.0/gems/logging-2.0.0/1ib/logging/diagnostic_context.rb:448:1
n ‘block in create_with_logging_context'
2015-12-30T17:30:47 [app] [I] Completed 500 Internal Server Error in 9.3ms

That's a big problem for us as we use this feature to add hosts to our rundeck projects. As it doesn't work, rundeck projects don't
have any nodes now.

Related issues:
Related to Foreman - Feature #11150: Allow searching of facts as types other ... Closed 07/19/2015
Related to Foreman - Bug #13035: Host fact search using ~ operator doesn't au... Duplicate

01/07/2016

Associated revisions

Revision 1e12a718 - 01/12/2016 05:01 AM - Dominic Cleal

fixes #12959 - escape % in fact search values, auto-add wildcards

When constructing fact search SQL queries with values containing
percent symbols (for LIKE queries), the symbols must be escaped as the
SQL conditions are later sanitised by Rails, which passes them through
the string formatter with any placeholder values from scoped_search.

Secondly, when using a LIKE search query without any wildcards,
previously a wildcard at the start and end would be added to match the
value anywhere. This behaviour has been restored.

Revision 0deffOee - 01/19/2016 09:18 AM - Dominic Cleal

fixes #12959 - escape % in fact search values, auto-add wildcards
When constructing fact search SQL queries with values containing
percent symbols (for LIKE queries), the symbols must be escaped as the

SQL conditions are later sanitised by Rails, which passes them through
the string formatter with any placeholder values from scoped_search.

Secondly, when using a LIKE search query without any wildcards,
previously a wildcard at the start and end would be added to match the
value anywhere. This behaviour has been restored.

(cherry picked from commit 1e12a718c17d9¢c2b0c65455e96102e7b4c2925a6)

History

#1 - 01/04/2016 03:25 AM - Dominic Cleal

- Category set to Search

Can you confirm which release(s) you're using? Are you saying it worked in 1.9.3 and now you're using 1.10.0 and it isn't?

#2 - 01/04/2016 03:28 AM - Brice Sauvajon

Yes, that's it, it worked on 1.9.3 and it's broken since the upgrade to 1.10.0

#3 - 01/04/2016 03:32 AM - Dominic Cleal
- Related to Feature #11150: Allow searching of facts as types other than string added

#4 - 01/04/2016 03:32 AM - Dominic Cleal

- translation missing: en.field_release set to 104

#5 - 01/07/2016 04:33 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#6 - 01/07/2016 05:11 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3026 added

#7 - 01/07/2016 05:19 AM - Dominic Cleal
- Related to Bug #13035: Host fact search using ~ operator doesn't automatically add wildcards added

#8 - 01/12/2016 06:03 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 1e12a718c17d9¢2b0c65455e96102e7b4c2925a6.
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/1e12a718c17d9c2b0c65455e96102e7b4c2925a6
